<!--
 nono
 Copyright (C) 2020 nono project
 Licensed under nono-license.txt
-->
<html>
<?php require_once "common.php"; ?>
<body>
<h3>nono: changes</h3>

Grey colored items are experimental and are just a log for us developers.
<hr>
<div class="main">
<dl>

<dt>0.1.4 (2020/11/20)
<dd><ul>
<li>vm (Fix): SCSI HD に WRITE(10) コマンドを実装。
 <q>Implement WRITE(10) command on SCSI HD.</q>
<li>vm (Fix): m88k の xmem.bu 命令のバグを修正。
 <q>Fix a bug on m88k xmem.bu instruction.</q>
<li>vm (Fix): m68k の STOP 命令や m88k の疑似 STOP
 状態で仮想時間がおかしくなる場合があるバグを修正。
 <q>Fix a bug that STOP instruction on m68k or pseudo STOP state on m88k
 may break virtual time.</q>
<li>vm (Fix): 0.1.3 以降 LUNA-I のエミュレーション ROM がキー入力を
 受け付けなくなっていたのを修正。
 <q>Fix a bug that LUNA-I emulated ROM does not accept any key inputs
 since 0.1.3.</q>
</ul></dd>
<p>

<dt>0.1.3 (2020/11/18)
<dd><ul>
<li>vm (Fix): m88k DAE エミュレーションを改善。
 <q>Improve DAE emulation on m88k.</q>
<li>vm (Fix): m88k ストア命令のバグを修正。
 <q>Fix a bug on m88k store instructions.</q>
<li>vm (Update): m88k の浮動小数点命令を実装中。
 <q>Implement floating point instructions.</q>
<li>vm (Fix): LUNA88K の RAM が正しくアクセスできてなかったのを修正。
 <q>Fix incorrect RAM device assignment on LUNA88K.</q>
<li>vm (Fix): LUNA88K のシステムクロックデバイスが正しくアクセスできてなかったのを修正。
 <q>Fix accessing to the system clock device on LUNA88K.</q>
<li>vm (Fix): uPD7201 (SIO) モニタの表示をいろいろ修正。
 <q>Various fixes on uPD7201 (SIO) monitor.</q>
<li>vm (Update): 割り込み周り全般を書き直し。
 <q>Rewrite and update whole around interrupt system.</q>
<li>vm (Update): SPC の SCMD Intercept ビットの動作を改善。
 <q>Improve SCMD's Intercept bit behavior on SPC.</q>
<li>debugger (Update): d,m コマンドなどメモリアクセス周りを改善。
 <q>Improve about memory access including d,m commands.</q>
<li>debugger (Update): 履歴のブランチ元に Supervisor/User 区分の表示を追加。
 <q>Show the Supervisor/User distinction of branch source address in
 branch windows.</q>
<li><span class=strike>vm (Update): X68k にダミーの OPM デバイスを用意。
 <q>Assign (currently no-op) OPM device on X68k.</q></span>
<li><span class=strike>vm (Update): MFP のタイマーの実装を改善中。
 <q>Improve MFP timer on X68k.</q></span>
</ul></dd>
<p>

<dt>0.1.2 (2020/10/28)
<dd><ul>
<li>build (Update): gcc5.5 以下はサポート外と明記。
<q>Mention explicitly that it does not support gcc5.5 or below.</q>
<li>vm (New): メモリとデバイスのアクセスウェイトをいくつか実装中。
<q>Implement access wait partially on some memory and devices.</q>
<li>vm (New): VM リセットを実装。<q>Implement VM reset.</q>
<li>vm (Fix): m88xx0 エミュレーションをいくつか改善。
OpenBSD/luna88k ユーザランドが少しだけ動くように。
<q>Improve some m88xx0 emulations.
This makes OpenBSD/luna88k userland apps work a little.</q>
<li>vm (Update): LUNA88K の RAM 初期値を 64MB に変更。
<q>Change the initial value of LUNA88K RAM to 64MB.</q>
<li>vm (Update): LUNA88K の dipsw1 の初期値を変更。
<q>Change the initial value of LUNA88K dipsw1.</q>
<li>debugger (Update): 設定の debugger-port の初期値を 0 に変更。
<q>Change the default value of debugger-port configuration field to 0.</q>
<li>debugger (Update): d, m, n, s, t, help コマンドを色々改良。
disp , reset コマンドを実装。
<q> Various improvements for d, m, n, s, t, and help commands.
Implement disp, reset commands.</q>
<li>wx (Fix): メインウィンドウの最大化とリサイズを不可にする。
<q>Disable main window's maximize and resize.</a>
<li>wx (Fix): ビッグエンディアン環境で wxIMAGE_QUALITY_HIGH
による縮小が化けるのを回避。
<q>Avoid broken resize using wxIMAGE_QUALITY_HIGH on big endian.</q>
</ul></dd>
<p>

<dt>0.1.1 (2020/10/06)
<dd><ul>
<li>host(Fix): sparc などのホストでミスアラインドアクセスで死ぬのを修正。
<q>Fix abnormal termination due to mis-aligned access on some architecture
hosts such as sparc.</q>
<li>vm (New): SCSI の Start Stop Unit コマンドをダミーで実装。
(OpenBSD カーネルが使っている)
<q>Implement SCSI Start Stop Unit command as no-op. (OpenBSD kernel uses it.)</q>
<li>vm (Fix): LUNA-I の PROM V4.22 以外はそのまま起動するようにしてみる。
<q>On LUNA-I, when PROM is other than V4.22, run it as is.</q>
<li>vm (Fix): SCSI コマンドがメディアサイズを超える位置やサイズを要求した時に死ぬのを修正。
<q>Fix abnormal termination when SCSI command requests exceeded position or length than actual media.</q>
<li>vm (Fix): LUNA-I エミュレーション ROM 上で、マウス操作でゴミが入力されるのを修正。
<q>Fix emitting garbage characters on mouse operation on LUNA-I emulated ROM.</q>
<li>GUI (New): LUNA のフロントパネル LCD ウィンドウを実装。
<q>Implement LUNA's front panel LCD window.</q>
<li>GUI (New): モニタウィンドウの更新頻度を設定可能にする。
<q>Make monitor window's refresh rate configureable.</q>
<li>GUI (New): ホスト情報ウィンドウ、ブレークポイントウィンドウ、履歴ウィンドウを実装。
<q>Implement host information window, breakpoint window, and
history window.</q>
<li>GUI (New): ログウィンドウのバックログを実装。
<q>Implement backlog of log window.</q>
<li>debugger (New): bi, bm, bv コマンドを実装。
<q>Implement bi, bm, and bv commands.</q>
<li>debugger (New): ブランチ履歴、例外履歴を実装。
<q>Implement branch history and exception history.</q>
<li>debugger (Fix): 逆アセンブラが 68020 の callm 命令で死んでいたのを修正。
<q>Fix abnormal termination when disassembling 68020 CALLM instruction.</q>
<li>vm (Fix): LUNA88K 用の luna-dipsw1 の初期値を用意。
<q>luna-dipsw1 uses a different initial value for LUNA88K.</q>
<li><span class=strike>vm (Update): X68k TVRAM レンダリングを改良。
<q>Improve performance on X68k TVRAM rendering.</q></span>
<li><span class=strike>debugger (Fix): 逆アセンブラで moveq.l が %d0 でない時にも IOCS コールと解釈していたのを修正。</span>
</ul></dd>
<p>

<dt>0.1.0 (2020/07/19)
<dd><ul>
<li>host(Fix): OpenBSD/FreeBSD でビルド可能に。
<q>Make it buildable on OpenBSD/FreeBSD.</q>
<li>GUI(Update): GUI メニューの L10N 対応
(GUI メニュー以外(ログメッセージなど)については当面対応予定はないです)。
<q>Support L10N for GUI menus
(There are no plans to support more messages (like log messages)
at least for now).</q>
<li>GUI(Fix): サブウィンドウを表示しているとマウスモードでクリック入力が入らなかった問題を修正。
<q>Fix problem that you can not enter any clicks in mouse mode
when you display some sub windows.</q>
<li>vm(New): m88k の疑似 STOP 状態に対応。
<q>Support pseudo STOP state on m88k.</q>

</ul></dd>
<p>


<dt>0.0.4 (2020/06/13)
<dd><ul>
<li>vm(Fix): 例外ベクタ取得中のバスエラーで死んでいたのを修正。
<q>Fix abnormal termination when fetching exception vector causes bus error.</q>
<li>vm(Update): ダブルバスフォールトを通知。
<q>Notify when double bus fault has occurred.</q>
<li>vm(New): m88100 の改良と m88200 を実装中。
OpenBSD/luna88k カーネルが起動しますが、
まだユーザランドに入るあたりまでです。
<q>Improve m88100 and implement m88200.
It can run OpenBSD/luna88k kernel and
it has just entered in userland.
</q>
<li><span class=strike>vm(New): x68k の MFP、DMAC を適当実装したので
実は NetBSD/x68k ブートローダまでは起動します。
CRTC が不完全なのでスクロールはまだできません。
<q>Implement MFP and DMAC in underground x68k mode.
It can run NetBSD/x68k boot loader.
However, CRTC emulation is not completed yet,
so you cannot scroll text.</q></span>
</ul></dd>
<p>

<dt>0.0.3 (2020/05/16)
<dd><ul>
<li>vm(New): ROM モニタエミュレーションを実装。<q>Support emulated ROM monitor.</q>
<li>vm(New): 地下で m88k 実装開始。
今のところ OpenBSD/luna88k のブートローダが起動できるだけです。
<q>Start to implement m88k in underground.
It just can run OpenBSD/luna88k's boot loader for now.
</q>
</ul></dd>
<p>

<dt>0.0.2 (2020/04/21)
<dd><ul>
<li>vm(New): SCSI エミュレーションを改善。<q>Improve(Reimplement) SCSI emulation.</q>
<li>vm(New): マウスをサポート。<q>Support mouse.</q>
<li>vm(Fix): RFCNT の Y 座標を修正。<q>Fix Y coordinate of RFCNT.</q>
</ul></dd>
<p>

<dt>0.0.1 (2020/03/06)
<dd><ul>
<li>Initial Release
</ul></dd>

</dl>
</div>
<hr>
nono project
</body>
</html>
