//
// nono
// Copyright (C) 2020 nono project
// Licensed under nono-license.txt
//

#pragma once

#include "rom.h"

class IPLROM1Device
	: public ROMDevice
{
	using inherited = ROMDevice;
 public:
	IPLROM1Device();
	virtual ~IPLROM1Device() override;

	bool Init() override;
};

class IPLROM2Device
	: public ROMDevice
{
	using inherited = ROMDevice;
 public:
	IPLROM2Device();
	virtual ~IPLROM2Device() override;

	bool Init() override;
};

class CGROMDevice
	: public ROMDevice
{
	using inherited = ROMDevice;
 public:
	CGROMDevice();
	virtual ~CGROMDevice() override;

	bool Init() override;
};

extern std::unique_ptr<CGROMDevice> gCGROM;
extern std::unique_ptr<IPLROM1Device> gIPLROM1;
extern std::unique_ptr<IPLROM2Device> gIPLROM2;
